# Propose Payment by Msig

The following guide will allow a user to propose a payment in DAPP by msig for the guardians to review.

```
git clone https://github.com/liquidapps-io/dappgovernance
cd dappgovernance/msigs
npm i
```

This will clone the governance repository, change directory into the msigs folder, and install the necessary magic to make the msig work, namely eosjs.

From here, you must create a `secrets.json` file in `/dappgovernance/msigs` where you will store the different variables.

```
{
    "to":"natdeveloper",
    "quantity":"1.0000 DAPP",
    "memo":"transfer",
    "private_key":"ACTUAL_PRIVATE_KEY_OF_MSIG_PROPOSER_HERE",
    "proposal_name":"testpayment",
    "msig_proposer":"zlwb4mcq322g",
    "expiration":"2021-11-29T23:11:48"
}
```

* `to` - the recipient of the DAPP
* `quantity` - the amount in DAPP to be transferred
* `memo` - optional memo for transfer
* `private_key` - this is the key for the `msig_proposer` account
* `proposal_name` - this is the name of the proposal must be a-z 1-5 and 12 or less characters in length
* `msig_proposer` - the account that is proposing the msig
* `expiration` - the expiration time for the trx, to make this easy simply update the year or month, in this case the example is November 29th, 2021 23:11:48 UTC.

Once you have your settings set, run the script with

```
node index.js
```

{% hint style="info" %}
If you need free CPU, see <https://eospowerup.io/free>
{% endhint %}

Here is an example msig that was cancelled: <https://bloks.io/msig/zlwb4mcq322g/testpayment>

If you do not have nodejs or npm installed on your computer, you can do so with the following commands:

```
curl -o- https://raw.githubusercontent.com/creationix/nvm/v0.34.0/install.sh | bash
```

There will be some output that looks like this:

```
export NVM_DIR="${XDG_CONFIG_HOME/:-$HOME/.}nvm"
[ -s "$NVM_DIR/nvm.sh" ] && \. "$NVM_DIR/nvm.sh"
```

Run those commands then run the following which will install nodejs / npm and retry the command:

```
nvm install 16
nvm use 16
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.liquidapps.io/liquidapps-documentation/eosio-guides/governance-guides/propose-payment-by-msig.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
